'
OPTION EXPLICIT
OPTION DEFAULT NONE
option base 1

dim integer True=1, False=0, Preserve=True, Destroy=False, i = 0, arg1=False
PrintHeap("     Program Start ")
dim string ArrData = ""

dim string ArrName = ""
dim integer ArrSize = 0
Dim string NewArrName = ""
dim integer NewArrSize = 1

dim string ArrCreate
dim string ArrDestroy
dim string ArrWrite
dim string ArrRead
dim string RedimCommand

PrintHeap("Variables Declared ")

ArrName = "InitArr"
ArrSize = 10
CreateArr
? "Initialise Completed..."

for i = 1 to ArrSize
  ArrData = ArrName + ", Array Element No. " + STR$(i)
  WriteToArr
next i

?
? "Reading Data from '" + ArrName + "' (" + str$(ArrSize) + " elements)"
for i = 1 to ArrSize
  ReadFromArr
next i

do
  '---- at the prompt, enter the data to ReDim the array
  '---- format = arg1, ArrName, ArrSize
  '---- arg1 = preserve|destroy (integer 1=true, 0=false)
  '----          preserve to retain any existing data in the original array
  '----          destroy to ReDim and remove all existing data
  '---- ArrName = The name of the array, either a new name or an existing name (string, without quotes)
  '---- ArrSize = New size of the array as required (integer)
  '----             0 to detroy the array
  '----             >2 to create the array
  '----             1 not a valid array size
  input arg1, ArrName, ArrSize 'wait for the input
  ReDim(arg1, ArrName, ArrSize) 'ReDim it
loop

sub CreateArr
  ? "   ... Creating arr : '" + ArrName + "' ... "
  ArrCreate = "dim string " + ArrName + "(" + str$(ArrSize) + ") length 40"
  execute ArrCreate
  PrintHeap("     Array Created ")
end sub

sub WriteToArr
  ArrWrite = ArrName + "(" + STR$(i) + ") = " + CHR$(34) + ArrData + CHR$(34)
  execute ArrWrite
  '---- uncomment here for more debug info
  '? "   Written data = " + ArrData
end sub

sub ReadFromArr
  ArrRead = "ArrData = " + ArrName + "(" + str$(i) + ")"
  execute ArrRead
  '---- uncomment here for more debug info
  '? "   Read data from element " + str$(i) + " in array name '" + arrname + "' = " + ArrData
end sub

sub PrintHeap(msg as string)
  ? msg + "~ Rem. Heap Mem = " + STR$(mm.info(heap))
end sub

sub ReDim (arg1 as integer, ArrName as string, ArrSize as integer)
  if ArrName = "" then exit sub
  if (arg1 <> 1) and (arg1 <> 0) then print "preserve|destroy not valid": exit sub 'preserve or destroy are the only options
  if ArrName = "" then print "Array Name not valid": exit sub 'the array must have a name
  if (ArrSize < 2) and (ArrSize <> 0) then print "Array Size not valid": exit sub 'must be bigger than 2 elements
  if ArrSize = 0 then 'if array size is set to 0, we want to delete it
    ArrDestroy = "erase " + ArrName + "()" 'set the command
    on error skip 'in case there's no such array name
    execute ArrDestroy 'delete the array
    PrintHeap(ArrName + " array deleted ") 'debug print
    exit sub 'done, get out
  endif
  select case arg1 'preserve or destroy
    case True 'preserve the data
      PrintHeap("      Redim(preserve) array start ") 'debug print
      local integer tmpSize 'temporary size for the original array
      local string GetSize 'original size variable
      local string tmpArr = "TempArr" 'name of the temporary working array
      GetSize = "tmpSize = Bound (" + ArrName + "())" 'get the uBound value of the original array
      on error skip 'in case the array doesn't exist
      execute GetSize 'get the array size
      if mm.errno > 0 then 'if the array wasn't found, then we need to create it
        ArrCreate = "dim string " + ArrName + "(" + str$(ArrSize) + ") length 40" 'set the command to create the new array
        execute ArrCreate 'create the array
        for i = 1 to ArrSize 'loop throught the new array
          ReadFromArr 'print the data
        next i
        PrintHeap("Redim(preserve) command completed ") 'debug print
        exit sub 'we're done, get out
      end if
      ArrCreate = "dim string " + tmpArr + "(" + str$(ArrSize) + ") length 40" 'set the command to create the new array
      execute ArrCreate 'create the array
      PrintHeap("          Temporary array created ") 'debug print
      for i = 1 to tmpSize
        ArrRead = "ArrData = " + ArrName + "(" + str$(i) + ")"
        execute ArrRead
        ArrWrite = tmpArr + "(" + STR$(i) + ") = " + CHR$(34) + ArrData + CHR$(34)
        on error skip
        execute ArrWrite
        if mm.errno > 0 then
          exit for
        end if
      next i
      PrintHeap("                     Array copied ") 'debug print
      ArrDestroy = "erase " + ArrName + "()" 'set the command
      on error skip 'in case the array doesn't exist or a new array is being created
      execute ArrDestroy 'destroy the array
      PrintHeap("         Original array destroyed ") 'debug print
      ArrCreate = "dim string " + ArrName + "(" + str$(ArrSize) + ") length 40" 'set the command to create the new array
      execute ArrCreate 'create the array
      for i = 1 to ArrSize
        ArrRead = "ArrData = " + tmpArr + "(" + str$(i) + ")"
        execute ArrRead
        ArrWrite = ArrName + "(" + STR$(i) + ") = " + CHR$(34) + ArrData + CHR$(34)
        execute ArrWrite
      next i
      PrintHeap("                Array copied back ") 'debug print
      ArrDestroy = "erase " + tmpArr + "()" 'set the command
      on error skip 'in case the array doesn't exist
      execute ArrDestroy 'destroy the array
      PrintHeap("        Temporary array destroyed ") 'debug print
      for i = 1 to ArrSize
        ReadFromArr
      next i
      PrintHeap("Redim(preserve) command completed ") 'debug print
    case False 'destroy the data
      ArrDestroy = "erase " + ArrName + "()" 'set the command
      on error skip 'in case the array doesn't exist or a new array is being created
      execute ArrDestroy 'destroy the array
      ArrCreate = "dim string " + ArrName + "(" + str$(ArrSize) + ") length 40" 'set the command to create the new array
      execute ArrCreate 'create the array
      for i = 1 to ArrSize '1 to number elements
        ArrData = "" 'set the array data with no information
        WriteToArr 'write the data to the array
      next i 'next element
      for i = 1 to ArrSize '1 to number of elements
        ReadFromArr 'read what's in the array
      next i 'next element
      PrintHeap("Redim(destroy) command completed ") 'debug print
    case else 'something else happened
      ? "Else" 'show it, but do nothing
  end select
  ?
end sub




